<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="generator" content="Asciidoctor 2.0.10">
<meta name="author" content="Jan Kolomazník">
<title>Spring: Security</title>
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,400italic,600,600italic%7CNoto+Serif:400,400italic,700,700italic%7CDroid+Sans+Mono:400,700">
<style>
/* Asciidoctor default stylesheet | MIT License | https://asciidoctor.org */
/* Uncomment @import statement to use as custom stylesheet */
/*@import "https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,400italic,600,600italic%7CNoto+Serif:400,400italic,700,700italic%7CDroid+Sans+Mono:400,700";*/
article,aside,details,figcaption,figure,footer,header,hgroup,main,nav,section{display:block}
audio,video{display:inline-block}
audio:not([controls]){display:none;height:0}
html{font-family:sans-serif;-ms-text-size-adjust:100%;-webkit-text-size-adjust:100%}
a{background:none}
a:focus{outline:thin dotted}
a:active,a:hover{outline:0}
h1{font-size:2em;margin:.67em 0}
abbr[title]{border-bottom:1px dotted}
b,strong{font-weight:bold}
dfn{font-style:italic}
hr{-moz-box-sizing:content-box;box-sizing:content-box;height:0}
mark{background:#ff0;color:#000}
code,kbd,pre,samp{font-family:monospace;font-size:1em}
pre{white-space:pre-wrap}
q{quotes:"\201C" "\201D" "\2018" "\2019"}
small{font-size:80%}
sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}
sup{top:-.5em}
sub{bottom:-.25em}
img{border:0}
svg:not(:root){overflow:hidden}
figure{margin:0}
fieldset{border:1px solid silver;margin:0 2px;padding:.35em .625em .75em}
legend{border:0;padding:0}
button,input,select,textarea{font-family:inherit;font-size:100%;margin:0}
button,input{line-height:normal}
button,select{text-transform:none}
button,html input[type="button"],input[type="reset"],input[type="submit"]{-webkit-appearance:button;cursor:pointer}
button[disabled],html input[disabled]{cursor:default}
input[type="checkbox"],input[type="radio"]{box-sizing:border-box;padding:0}
button::-moz-focus-inner,input::-moz-focus-inner{border:0;padding:0}
textarea{overflow:auto;vertical-align:top}
table{border-collapse:collapse;border-spacing:0}
*,*::before,*::after{-moz-box-sizing:border-box;-webkit-box-sizing:border-box;box-sizing:border-box}
html,body{font-size:100%}
body{background:#fff;color:rgba(0,0,0,.8);padding:0;margin:0;font-family:"Noto Serif","DejaVu Serif",serif;font-weight:400;font-style:normal;line-height:1;position:relative;cursor:auto;tab-size:4;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased}
a:hover{cursor:pointer}
img,object,embed{max-width:100%;height:auto}
object,embed{height:100%}
img{-ms-interpolation-mode:bicubic}
.left{float:left!important}
.right{float:right!important}
.text-left{text-align:left!important}
.text-right{text-align:right!important}
.text-center{text-align:center!important}
.text-justify{text-align:justify!important}
.hide{display:none}
img,object,svg{display:inline-block;vertical-align:middle}
textarea{height:auto;min-height:50px}
select{width:100%}
.center{margin-left:auto;margin-right:auto}
.stretch{width:100%}
.subheader,.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{line-height:1.45;color:#7a2518;font-weight:400;margin-top:0;margin-bottom:.25em}
div,dl,dt,dd,ul,ol,li,h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6,pre,form,p,blockquote,th,td{margin:0;padding:0;direction:ltr}
a{color:#2156a5;text-decoration:underline;line-height:inherit}
a:hover,a:focus{color:#1d4b8f}
a img{border:0}
p{font-family:inherit;font-weight:400;font-size:1em;line-height:1.6;margin-bottom:1.25em;text-rendering:optimizeLegibility}
p aside{font-size:.875em;line-height:1.35;font-style:italic}
h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{font-family:"Open Sans","DejaVu Sans",sans-serif;font-weight:300;font-style:normal;color:#ba3925;text-rendering:optimizeLegibility;margin-top:1em;margin-bottom:.5em;line-height:1.0125em}
h1 small,h2 small,h3 small,#toctitle small,.sidebarblock>.content>.title small,h4 small,h5 small,h6 small{font-size:60%;color:#e99b8f;line-height:0}
h1{font-size:2.125em}
h2{font-size:1.6875em}
h3,#toctitle,.sidebarblock>.content>.title{font-size:1.375em}
h4,h5{font-size:1.125em}
h6{font-size:1em}
hr{border:solid #dddddf;border-width:1px 0 0;clear:both;margin:1.25em 0 1.1875em;height:0}
em,i{font-style:italic;line-height:inherit}
strong,b{font-weight:bold;line-height:inherit}
small{font-size:60%;line-height:inherit}
code{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;font-weight:400;color:rgba(0,0,0,.9)}
ul,ol,dl{font-size:1em;line-height:1.6;margin-bottom:1.25em;list-style-position:outside;font-family:inherit}
ul,ol{margin-left:1.5em}
ul li ul,ul li ol{margin-left:1.25em;margin-bottom:0;font-size:1em}
ul.square li ul,ul.circle li ul,ul.disc li ul{list-style:inherit}
ul.square{list-style-type:square}
ul.circle{list-style-type:circle}
ul.disc{list-style-type:disc}
ol li ul,ol li ol{margin-left:1.25em;margin-bottom:0}
dl dt{margin-bottom:.3125em;font-weight:bold}
dl dd{margin-bottom:1.25em}
abbr,acronym{text-transform:uppercase;font-size:90%;color:rgba(0,0,0,.8);border-bottom:1px dotted #ddd;cursor:help}
abbr{text-transform:none}
blockquote{margin:0 0 1.25em;padding:.5625em 1.25em 0 1.1875em;border-left:1px solid #ddd}
blockquote cite{display:block;font-size:.9375em;color:rgba(0,0,0,.6)}
blockquote cite::before{content:"\2014 \0020"}
blockquote cite a,blockquote cite a:visited{color:rgba(0,0,0,.6)}
blockquote,blockquote p{line-height:1.6;color:rgba(0,0,0,.85)}
@media screen and (min-width:768px){h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2}
h1{font-size:2.75em}
h2{font-size:2.3125em}
h3,#toctitle,.sidebarblock>.content>.title{font-size:1.6875em}
h4{font-size:1.4375em}}
table{background:#fff;margin-bottom:1.25em;border:solid 1px #dedede}
table thead,table tfoot{background:#f7f8f7}
table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;color:rgba(0,0,0,.8);text-align:left}
table tr th,table tr td{padding:.5625em .625em;font-size:inherit;color:rgba(0,0,0,.8)}
table tr.even,table tr.alt{background:#f8f8f7}
table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{display:table-cell;line-height:1.6}
h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2;word-spacing:-.05em}
h1 strong,h2 strong,h3 strong,#toctitle strong,.sidebarblock>.content>.title strong,h4 strong,h5 strong,h6 strong{font-weight:400}
.clearfix::before,.clearfix::after,.float-group::before,.float-group::after{content:" ";display:table}
.clearfix::after,.float-group::after{clear:both}
:not(pre):not([class^=L])>code{font-size:.9375em;font-style:normal!important;letter-spacing:0;padding:.1em .5ex;word-spacing:-.15em;background:#f7f7f8;-webkit-border-radius:4px;border-radius:4px;line-height:1.45;text-rendering:optimizeSpeed;word-wrap:break-word}
:not(pre)>code.nobreak{word-wrap:normal}
:not(pre)>code.nowrap{white-space:nowrap}
pre{color:rgba(0,0,0,.9);font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;line-height:1.45;text-rendering:optimizeSpeed}
pre code,pre pre{color:inherit;font-size:inherit;line-height:inherit}
pre>code{display:block}
pre.nowrap,pre.nowrap pre{white-space:pre;word-wrap:normal}
em em{font-style:normal}
strong strong{font-weight:400}
.keyseq{color:rgba(51,51,51,.8)}
kbd{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;display:inline-block;color:rgba(0,0,0,.8);font-size:.65em;line-height:1.45;background:#f7f7f7;border:1px solid #ccc;-webkit-border-radius:3px;border-radius:3px;-webkit-box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em white inset;box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em #fff inset;margin:0 .15em;padding:.2em .5em;vertical-align:middle;position:relative;top:-.1em;white-space:nowrap}
.keyseq kbd:first-child{margin-left:0}
.keyseq kbd:last-child{margin-right:0}
.menuseq,.menuref{color:#000}
.menuseq b:not(.caret),.menuref{font-weight:inherit}
.menuseq{word-spacing:-.02em}
.menuseq b.caret{font-size:1.25em;line-height:.8}
.menuseq i.caret{font-weight:bold;text-align:center;width:.45em}
b.button::before,b.button::after{position:relative;top:-1px;font-weight:400}
b.button::before{content:"[";padding:0 3px 0 2px}
b.button::after{content:"]";padding:0 2px 0 3px}
p a>code:hover{color:rgba(0,0,0,.9)}
#header,#content,#footnotes,#footer{width:100%;margin-left:auto;margin-right:auto;margin-top:0;margin-bottom:0;max-width:62.5em;*zoom:1;position:relative;padding-left:.9375em;padding-right:.9375em}
#header::before,#header::after,#content::before,#content::after,#footnotes::before,#footnotes::after,#footer::before,#footer::after{content:" ";display:table}
#header::after,#content::after,#footnotes::after,#footer::after{clear:both}
#content{margin-top:1.25em}
#content::before{content:none}
#header>h1:first-child{color:rgba(0,0,0,.85);margin-top:2.25rem;margin-bottom:0}
#header>h1:first-child+#toc{margin-top:8px;border-top:1px solid #dddddf}
#header>h1:only-child,body.toc2 #header>h1:nth-last-child(2){border-bottom:1px solid #dddddf;padding-bottom:8px}
#header .details{border-bottom:1px solid #dddddf;line-height:1.45;padding-top:.25em;padding-bottom:.25em;padding-left:.25em;color:rgba(0,0,0,.6);display:-ms-flexbox;display:-webkit-flex;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap}
#header .details span:first-child{margin-left:-.125em}
#header .details span.email a{color:rgba(0,0,0,.85)}
#header .details br{display:none}
#header .details br+span::before{content:"\00a0\2013\00a0"}
#header .details br+span.author::before{content:"\00a0\22c5\00a0";color:rgba(0,0,0,.85)}
#header .details br+span#revremark::before{content:"\00a0|\00a0"}
#header #revnumber{text-transform:capitalize}
#header #revnumber::after{content:"\00a0"}
#content>h1:first-child:not([class]){color:rgba(0,0,0,.85);border-bottom:1px solid #dddddf;padding-bottom:8px;margin-top:0;padding-top:1rem;margin-bottom:1.25rem}
#toc{border-bottom:1px solid #e7e7e9;padding-bottom:.5em}
#toc>ul{margin-left:.125em}
#toc ul.sectlevel0>li>a{font-style:italic}
#toc ul.sectlevel0 ul.sectlevel1{margin:.5em 0}
#toc ul{font-family:"Open Sans","DejaVu Sans",sans-serif;list-style-type:none}
#toc li{line-height:1.3334;margin-top:.3334em}
#toc a{text-decoration:none}
#toc a:active{text-decoration:underline}
#toctitle{color:#7a2518;font-size:1.2em}
@media screen and (min-width:768px){#toctitle{font-size:1.375em}
body.toc2{padding-left:15em;padding-right:0}
#toc.toc2{margin-top:0!important;background:#f8f8f7;position:fixed;width:15em;left:0;top:0;border-right:1px solid #e7e7e9;border-top-width:0!important;border-bottom-width:0!important;z-index:1000;padding:1.25em 1em;height:100%;overflow:auto}
#toc.toc2 #toctitle{margin-top:0;margin-bottom:.8rem;font-size:1.2em}
#toc.toc2>ul{font-size:.9em;margin-bottom:0}
#toc.toc2 ul ul{margin-left:0;padding-left:1em}
#toc.toc2 ul.sectlevel0 ul.sectlevel1{padding-left:0;margin-top:.5em;margin-bottom:.5em}
body.toc2.toc-right{padding-left:0;padding-right:15em}
body.toc2.toc-right #toc.toc2{border-right-width:0;border-left:1px solid #e7e7e9;left:auto;right:0}}
@media screen and (min-width:1280px){body.toc2{padding-left:20em;padding-right:0}
#toc.toc2{width:20em}
#toc.toc2 #toctitle{font-size:1.375em}
#toc.toc2>ul{font-size:.95em}
#toc.toc2 ul ul{padding-left:1.25em}
body.toc2.toc-right{padding-left:0;padding-right:20em}}
#content #toc{border-style:solid;border-width:1px;border-color:#e0e0dc;margin-bottom:1.25em;padding:1.25em;background:#f8f8f7;-webkit-border-radius:4px;border-radius:4px}
#content #toc>:first-child{margin-top:0}
#content #toc>:last-child{margin-bottom:0}
#footer{max-width:100%;background:rgba(0,0,0,.8);padding:1.25em}
#footer-text{color:rgba(255,255,255,.8);line-height:1.44}
#content{margin-bottom:.625em}
.sect1{padding-bottom:.625em}
@media screen and (min-width:768px){#content{margin-bottom:1.25em}
.sect1{padding-bottom:1.25em}}
.sect1:last-child{padding-bottom:0}
.sect1+.sect1{border-top:1px solid #e7e7e9}
#content h1>a.anchor,h2>a.anchor,h3>a.anchor,#toctitle>a.anchor,.sidebarblock>.content>.title>a.anchor,h4>a.anchor,h5>a.anchor,h6>a.anchor{position:absolute;z-index:1001;width:1.5ex;margin-left:-1.5ex;display:block;text-decoration:none!important;visibility:hidden;text-align:center;font-weight:400}
#content h1>a.anchor::before,h2>a.anchor::before,h3>a.anchor::before,#toctitle>a.anchor::before,.sidebarblock>.content>.title>a.anchor::before,h4>a.anchor::before,h5>a.anchor::before,h6>a.anchor::before{content:"\00A7";font-size:.85em;display:block;padding-top:.1em}
#content h1:hover>a.anchor,#content h1>a.anchor:hover,h2:hover>a.anchor,h2>a.anchor:hover,h3:hover>a.anchor,#toctitle:hover>a.anchor,.sidebarblock>.content>.title:hover>a.anchor,h3>a.anchor:hover,#toctitle>a.anchor:hover,.sidebarblock>.content>.title>a.anchor:hover,h4:hover>a.anchor,h4>a.anchor:hover,h5:hover>a.anchor,h5>a.anchor:hover,h6:hover>a.anchor,h6>a.anchor:hover{visibility:visible}
#content h1>a.link,h2>a.link,h3>a.link,#toctitle>a.link,.sidebarblock>.content>.title>a.link,h4>a.link,h5>a.link,h6>a.link{color:#ba3925;text-decoration:none}
#content h1>a.link:hover,h2>a.link:hover,h3>a.link:hover,#toctitle>a.link:hover,.sidebarblock>.content>.title>a.link:hover,h4>a.link:hover,h5>a.link:hover,h6>a.link:hover{color:#a53221}
details,.audioblock,.imageblock,.literalblock,.listingblock,.stemblock,.videoblock{margin-bottom:1.25em}
details>summary:first-of-type{cursor:pointer;display:list-item;outline:none;margin-bottom:.75em}
.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{text-rendering:optimizeLegibility;text-align:left;font-family:"Noto Serif","DejaVu Serif",serif;font-size:1rem;font-style:italic}
table.tableblock.fit-content>caption.title{white-space:nowrap;width:0}
.paragraph.lead>p,#preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:1.21875em;line-height:1.6;color:rgba(0,0,0,.85)}
table.tableblock #preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:inherit}
.admonitionblock>table{border-collapse:separate;border:0;background:none;width:100%}
.admonitionblock>table td.icon{text-align:center;width:80px}
.admonitionblock>table td.icon img{max-width:none}
.admonitionblock>table td.icon .title{font-weight:bold;font-family:"Open Sans","DejaVu Sans",sans-serif;text-transform:uppercase}
.admonitionblock>table td.content{padding-left:1.125em;padding-right:1.25em;border-left:1px solid #dddddf;color:rgba(0,0,0,.6)}
.admonitionblock>table td.content>:last-child>:last-child{margin-bottom:0}
.exampleblock>.content{border-style:solid;border-width:1px;border-color:#e6e6e6;margin-bottom:1.25em;padding:1.25em;background:#fff;-webkit-border-radius:4px;border-radius:4px}
.exampleblock>.content>:first-child{margin-top:0}
.exampleblock>.content>:last-child{margin-bottom:0}
.sidebarblock{border-style:solid;border-width:1px;border-color:#dbdbd6;margin-bottom:1.25em;padding:1.25em;background:#f3f3f2;-webkit-border-radius:4px;border-radius:4px}
.sidebarblock>:first-child{margin-top:0}
.sidebarblock>:last-child{margin-bottom:0}
.sidebarblock>.content>.title{color:#7a2518;margin-top:0;text-align:center}
.exampleblock>.content>:last-child>:last-child,.exampleblock>.content .olist>ol>li:last-child>:last-child,.exampleblock>.content .ulist>ul>li:last-child>:last-child,.exampleblock>.content .qlist>ol>li:last-child>:last-child,.sidebarblock>.content>:last-child>:last-child,.sidebarblock>.content .olist>ol>li:last-child>:last-child,.sidebarblock>.content .ulist>ul>li:last-child>:last-child,.sidebarblock>.content .qlist>ol>li:last-child>:last-child{margin-bottom:0}
.literalblock pre,.listingblock>.content>pre{-webkit-border-radius:4px;border-radius:4px;word-wrap:break-word;overflow-x:auto;padding:1em;font-size:.8125em}
@media screen and (min-width:768px){.literalblock pre,.listingblock>.content>pre{font-size:.90625em}}
@media screen and (min-width:1280px){.literalblock pre,.listingblock>.content>pre{font-size:1em}}
.literalblock pre,.listingblock>.content>pre:not(.highlight),.listingblock>.content>pre[class="highlight"],.listingblock>.content>pre[class^="highlight "]{background:#f7f7f8}
.literalblock.output pre{color:#f7f7f8;background:rgba(0,0,0,.9)}
.listingblock>.content{position:relative}
.listingblock code[data-lang]::before{display:none;content:attr(data-lang);position:absolute;font-size:.75em;top:.425rem;right:.5rem;line-height:1;text-transform:uppercase;color:inherit;opacity:.5}
.listingblock:hover code[data-lang]::before{display:block}
.listingblock.terminal pre .command::before{content:attr(data-prompt);padding-right:.5em;color:inherit;opacity:.5}
.listingblock.terminal pre .command:not([data-prompt])::before{content:"$"}
.listingblock pre.highlightjs{padding:0}
.listingblock pre.highlightjs>code{padding:1em;-webkit-border-radius:4px;border-radius:4px}
.listingblock pre.prettyprint{border-width:0}
.prettyprint{background:#f7f7f8}
pre.prettyprint .linenums{line-height:1.45;margin-left:2em}
pre.prettyprint li{background:none;list-style-type:inherit;padding-left:0}
pre.prettyprint li code[data-lang]::before{opacity:1}
pre.prettyprint li:not(:first-child) code[data-lang]::before{display:none}
table.linenotable{border-collapse:separate;border:0;margin-bottom:0;background:none}
table.linenotable td[class]{color:inherit;vertical-align:top;padding:0;line-height:inherit;white-space:normal}
table.linenotable td.code{padding-left:.75em}
table.linenotable td.linenos{border-right:1px solid currentColor;opacity:.35;padding-right:.5em}
pre.pygments .lineno{border-right:1px solid currentColor;opacity:.35;display:inline-block;margin-right:.75em}
pre.pygments .lineno::before{content:"";margin-right:-.125em}
.quoteblock{margin:0 1em 1.25em 1.5em;display:table}
.quoteblock:not(.excerpt)>.title{margin-left:-1.5em;margin-bottom:.75em}
.quoteblock blockquote,.quoteblock p{color:rgba(0,0,0,.85);font-size:1.15rem;line-height:1.75;word-spacing:.1em;letter-spacing:0;font-style:italic;text-align:justify}
.quoteblock blockquote{margin:0;padding:0;border:0}
.quoteblock blockquote::before{content:"\201c";float:left;font-size:2.75em;font-weight:bold;line-height:.6em;margin-left:-.6em;color:#7a2518;text-shadow:0 1px 2px rgba(0,0,0,.1)}
.quoteblock blockquote>.paragraph:last-child p{margin-bottom:0}
.quoteblock .attribution{margin-top:.75em;margin-right:.5ex;text-align:right}
.verseblock{margin:0 1em 1.25em}
.verseblock pre{font-family:"Open Sans","DejaVu Sans",sans;font-size:1.15rem;color:rgba(0,0,0,.85);font-weight:300;text-rendering:optimizeLegibility}
.verseblock pre strong{font-weight:400}
.verseblock .attribution{margin-top:1.25rem;margin-left:.5ex}
.quoteblock .attribution,.verseblock .attribution{font-size:.9375em;line-height:1.45;font-style:italic}
.quoteblock .attribution br,.verseblock .attribution br{display:none}
.quoteblock .attribution cite,.verseblock .attribution cite{display:block;letter-spacing:-.025em;color:rgba(0,0,0,.6)}
.quoteblock.abstract blockquote::before,.quoteblock.excerpt blockquote::before,.quoteblock .quoteblock blockquote::before{display:none}
.quoteblock.abstract blockquote,.quoteblock.abstract p,.quoteblock.excerpt blockquote,.quoteblock.excerpt p,.quoteblock .quoteblock blockquote,.quoteblock .quoteblock p{line-height:1.6;word-spacing:0}
.quoteblock.abstract{margin:0 1em 1.25em;display:block}
.quoteblock.abstract>.title{margin:0 0 .375em;font-size:1.15em;text-align:center}
.quoteblock.excerpt>blockquote,.quoteblock .quoteblock{padding:0 0 .25em 1em;border-left:.25em solid #dddddf}
.quoteblock.excerpt,.quoteblock .quoteblock{margin-left:0}
.quoteblock.excerpt blockquote,.quoteblock.excerpt p,.quoteblock .quoteblock blockquote,.quoteblock .quoteblock p{color:inherit;font-size:1.0625rem}
.quoteblock.excerpt .attribution,.quoteblock .quoteblock .attribution{color:inherit;text-align:left;margin-right:0}
table.tableblock{max-width:100%;border-collapse:separate}
p.tableblock:last-child{margin-bottom:0}
td.tableblock>.content>:last-child{margin-bottom:-1.25em}
td.tableblock>.content>:last-child.sidebarblock{margin-bottom:0}
table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
table.grid-all>thead>tr>.tableblock,table.grid-all>tbody>tr>.tableblock{border-width:0 1px 1px 0}
table.grid-all>tfoot>tr>.tableblock{border-width:1px 1px 0 0}
table.grid-cols>*>tr>.tableblock{border-width:0 1px 0 0}
table.grid-rows>thead>tr>.tableblock,table.grid-rows>tbody>tr>.tableblock{border-width:0 0 1px}
table.grid-rows>tfoot>tr>.tableblock{border-width:1px 0 0}
table.grid-all>*>tr>.tableblock:last-child,table.grid-cols>*>tr>.tableblock:last-child{border-right-width:0}
table.grid-all>tbody>tr:last-child>.tableblock,table.grid-all>thead:last-child>tr>.tableblock,table.grid-rows>tbody>tr:last-child>.tableblock,table.grid-rows>thead:last-child>tr>.tableblock{border-bottom-width:0}
table.frame-all{border-width:1px}
table.frame-sides{border-width:0 1px}
table.frame-topbot,table.frame-ends{border-width:1px 0}
table.stripes-all tr,table.stripes-odd tr:nth-of-type(odd),table.stripes-even tr:nth-of-type(even),table.stripes-hover tr:hover{background:#f8f8f7}
th.halign-left,td.halign-left{text-align:left}
th.halign-right,td.halign-right{text-align:right}
th.halign-center,td.halign-center{text-align:center}
th.valign-top,td.valign-top{vertical-align:top}
th.valign-bottom,td.valign-bottom{vertical-align:bottom}
th.valign-middle,td.valign-middle{vertical-align:middle}
table thead th,table tfoot th{font-weight:bold}
tbody tr th{display:table-cell;line-height:1.6;background:#f7f8f7}
tbody tr th,tbody tr th p,tfoot tr th,tfoot tr th p{color:rgba(0,0,0,.8);font-weight:bold}
p.tableblock>code:only-child{background:none;padding:0}
p.tableblock{font-size:1em}
ol{margin-left:1.75em}
ul li ol{margin-left:1.5em}
dl dd{margin-left:1.125em}
dl dd:last-child,dl dd:last-child>:last-child{margin-bottom:0}
ol>li p,ul>li p,ul dd,ol dd,.olist .olist,.ulist .ulist,.ulist .olist,.olist .ulist{margin-bottom:.625em}
ul.checklist,ul.none,ol.none,ul.no-bullet,ol.no-bullet,ol.unnumbered,ul.unstyled,ol.unstyled{list-style-type:none}
ul.no-bullet,ol.no-bullet,ol.unnumbered{margin-left:.625em}
ul.unstyled,ol.unstyled{margin-left:0}
ul.checklist{margin-left:.625em}
ul.checklist li>p:first-child>.fa-square-o:first-child,ul.checklist li>p:first-child>.fa-check-square-o:first-child{width:1.25em;font-size:.8em;position:relative;bottom:.125em}
ul.checklist li>p:first-child>input[type="checkbox"]:first-child{margin-right:.25em}
ul.inline{display:-ms-flexbox;display:-webkit-box;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap;list-style:none;margin:0 0 .625em -1.25em}
ul.inline>li{margin-left:1.25em}
.unstyled dl dt{font-weight:400;font-style:normal}
ol.arabic{list-style-type:decimal}
ol.decimal{list-style-type:decimal-leading-zero}
ol.loweralpha{list-style-type:lower-alpha}
ol.upperalpha{list-style-type:upper-alpha}
ol.lowerroman{list-style-type:lower-roman}
ol.upperroman{list-style-type:upper-roman}
ol.lowergreek{list-style-type:lower-greek}
.hdlist>table,.colist>table{border:0;background:none}
.hdlist>table>tbody>tr,.colist>table>tbody>tr{background:none}
td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
td.hdlist1{font-weight:bold;padding-bottom:1.25em}
.literalblock+.colist,.listingblock+.colist{margin-top:-.5em}
.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
.colist td:not([class]):first-child img{max-width:none}
.colist td:not([class]):last-child{padding:.25em 0}
.thumb,.th{line-height:0;display:inline-block;border:solid 4px #fff;-webkit-box-shadow:0 0 0 1px #ddd;box-shadow:0 0 0 1px #ddd}
.imageblock.left{margin:.25em .625em 1.25em 0}
.imageblock.right{margin:.25em 0 1.25em .625em}
.imageblock>.title{margin-bottom:0}
.imageblock.thumb,.imageblock.th{border-width:6px}
.imageblock.thumb>.title,.imageblock.th>.title{padding:0 .125em}
.image.left,.image.right{margin-top:.25em;margin-bottom:.25em;display:inline-block;line-height:0}
.image.left{margin-right:.625em}
.image.right{margin-left:.625em}
a.image{text-decoration:none;display:inline-block}
a.image object{pointer-events:none}
sup.footnote,sup.footnoteref{font-size:.875em;position:static;vertical-align:super}
sup.footnote a,sup.footnoteref a{text-decoration:none}
sup.footnote a:active,sup.footnoteref a:active{text-decoration:underline}
#footnotes{padding-top:.75em;padding-bottom:.75em;margin-bottom:.625em}
#footnotes hr{width:20%;min-width:6.25em;margin:-.25em 0 .75em;border-width:1px 0 0}
#footnotes .footnote{padding:0 .375em 0 .225em;line-height:1.3334;font-size:.875em;margin-left:1.2em;margin-bottom:.2em}
#footnotes .footnote a:first-of-type{font-weight:bold;text-decoration:none;margin-left:-1.05em}
#footnotes .footnote:last-of-type{margin-bottom:0}
#content #footnotes{margin-top:-.625em;margin-bottom:0;padding:.75em 0}
.gist .file-data>table{border:0;background:#fff;width:100%;margin-bottom:0}
.gist .file-data>table td.line-data{width:99%}
div.unbreakable{page-break-inside:avoid}
.big{font-size:larger}
.small{font-size:smaller}
.underline{text-decoration:underline}
.overline{text-decoration:overline}
.line-through{text-decoration:line-through}
.aqua{color:#00bfbf}
.aqua-background{background:#00fafa}
.black{color:#000}
.black-background{background:#000}
.blue{color:#0000bf}
.blue-background{background:#0000fa}
.fuchsia{color:#bf00bf}
.fuchsia-background{background:#fa00fa}
.gray{color:#606060}
.gray-background{background:#7d7d7d}
.green{color:#006000}
.green-background{background:#007d00}
.lime{color:#00bf00}
.lime-background{background:#00fa00}
.maroon{color:#600000}
.maroon-background{background:#7d0000}
.navy{color:#000060}
.navy-background{background:#00007d}
.olive{color:#606000}
.olive-background{background:#7d7d00}
.purple{color:#600060}
.purple-background{background:#7d007d}
.red{color:#bf0000}
.red-background{background:#fa0000}
.silver{color:#909090}
.silver-background{background:#bcbcbc}
.teal{color:#006060}
.teal-background{background:#007d7d}
.white{color:#bfbfbf}
.white-background{background:#fafafa}
.yellow{color:#bfbf00}
.yellow-background{background:#fafa00}
span.icon>.fa{cursor:default}
a span.icon>.fa{cursor:inherit}
.admonitionblock td.icon [class^="fa icon-"]{font-size:2.5em;text-shadow:1px 1px 2px rgba(0,0,0,.5);cursor:default}
.admonitionblock td.icon .icon-note::before{content:"\f05a";color:#19407c}
.admonitionblock td.icon .icon-tip::before{content:"\f0eb";text-shadow:1px 1px 2px rgba(155,155,0,.8);color:#111}
.admonitionblock td.icon .icon-warning::before{content:"\f071";color:#bf6900}
.admonitionblock td.icon .icon-caution::before{content:"\f06d";color:#bf3400}
.admonitionblock td.icon .icon-important::before{content:"\f06a";color:#bf0000}
.conum[data-value]{display:inline-block;color:#fff!important;background:rgba(0,0,0,.8);-webkit-border-radius:100px;border-radius:100px;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]::after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}
dt,th.tableblock,td.content,div.footnote{text-rendering:optimizeLegibility}
h1,h2,p,td.content,span.alt{letter-spacing:-.01em}
p strong,td.content strong,div.footnote strong{letter-spacing:-.005em}
p,blockquote,dt,td.content,span.alt{font-size:1.0625rem}
p{margin-bottom:1.25rem}
.sidebarblock p,.sidebarblock dt,.sidebarblock td.content,p.tableblock{font-size:1em}
.exampleblock>.content{background:#fffef7;border-color:#e0e0dc;-webkit-box-shadow:0 1px 4px #e0e0dc;box-shadow:0 1px 4px #e0e0dc}
.print-only{display:none!important}
@page{margin:1.25cm .75cm}
@media print{*{-webkit-box-shadow:none!important;box-shadow:none!important;text-shadow:none!important}
html{font-size:80%}
a{color:inherit!important;text-decoration:underline!important}
a.bare,a[href^="#"],a[href^="mailto:"]{text-decoration:none!important}
a[href^="http:"]:not(.bare)::after,a[href^="https:"]:not(.bare)::after{content:"(" attr(href) ")";display:inline-block;font-size:.875em;padding-left:.25em}
abbr[title]::after{content:" (" attr(title) ")"}
pre,blockquote,tr,img,object,svg{page-break-inside:avoid}
thead{display:table-header-group}
svg{max-width:100%}
p,blockquote,dt,td.content{font-size:1em;orphans:3;widows:3}
h2,h3,#toctitle,.sidebarblock>.content>.title{page-break-after:avoid}
#toc,.sidebarblock,.exampleblock>.content{background:none!important}
#toc{border-bottom:1px solid #dddddf!important;padding-bottom:0!important}
body.book #header{text-align:center}
body.book #header>h1:first-child{border:0!important;margin:2.5em 0 1em}
body.book #header .details{border:0!important;display:block;padding:0!important}
body.book #header .details span:first-child{margin-left:0!important}
body.book #header .details br{display:block}
body.book #header .details br+span::before{content:none!important}
body.book #toc{border:0!important;text-align:left!important;padding:0!important;margin:0!important}
body.book #toc,body.book #preamble,body.book h1.sect0,body.book .sect1>h2{page-break-before:always}
.listingblock code[data-lang]::before{display:block}
#footer{padding:0 .9375em}
.hide-on-print{display:none!important}
.print-only{display:block!important}
.hide-for-print{display:none!important}
.show-for-print{display:inherit!important}}
@media print,amzn-kf8{#header>h1:first-child{margin-top:1.25rem}
.sect1{padding:0!important}
.sect1+.sect1{border:0}
#footer{background:none}
#footer-text{color:rgba(0,0,0,.6);font-size:.9em}}
@media amzn-kf8{#header,#content,#footnotes,#footer{padding:0}}
</style>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>
<body class="article toc2 toc-left">
<div id="header">
<h1>Spring: Security</h1>
<div class="details">
<span id="author" class="author">Jan Kolomazník</span><br>
<span id="email" class="email"><a href="mailto:jan.kolomaznik@gmail.com">jan.kolomaznik@gmail.com</a></span><br>
<span id="revnumber">version 1.1,</span>
<span id="revdate">2020-07-03</span>
</div>
<div id="toc" class="toc2">
<div id="toctitle">Table of Contents</div>
<ul class="sectlevel1">
<li><a href="#_úvod">Úvod</a>
<ul class="sectlevel2">
<li><a href="#_authentication">Authentication</a></li>
<li><a href="#_přizpůsobení_authentication_managers">Přizpůsobení Authentication Managers</a></li>
<li><a href="#_authorization_or_access_control">Authorization or Access Control</a></li>
<li><a href="#_accessdecisionvoter_a_proces_authorization">AccessDecisionVoter a proces Authorization</a></li>
</ul>
</li>
<li><a href="#_web_security">Web Security</a></li>
<li><a href="#_filter_chain">Filter chain</a>
<ul class="sectlevel3">
<li><a href="#_spring_security_filters">Spring security filters</a></li>
<li><a href="#_detailnější_pohled">Detailnější pohled</a></li>
<li><a href="#_creating_and_customizing_filter_chains">Creating and Customizing Filter Chains</a></li>
<li><a href="#_request_matching_for_dispatch_and_authorization">Request Matching for Dispatch and Authorization</a></li>
</ul>
</li>
<li><a href="#_method_security">Method Security</a>
<ul class="sectlevel2">
<li><a href="#_todo">TODO</a></li>
</ul>
</li>
</ul>
</div>
</div>
<div id="content">
<div class="sect1">
<h2 id="_úvod">Úvod</h2>
<div class="sectionbody">
<div class="paragraph">
<p>Bezpečnost aplikací se skládá ze dvou více či méně nezávislé kroků</p>
</div>
<div class="ulist">
<ul>
<li>
<p><strong>Authentication</strong>: kdo jste?</p>
</li>
<li>
<p><strong>Authorization</strong>: co máte povoleno dělat?.</p>
</li>
</ul>
</div>
<div class="paragraph">
<p>Někdy lidé říkají "kontrola přístupu" namísto "autorizace"</p>
</div>
<div class="paragraph">
<p>Ve spring se obě části konfigují nezávisle na různých místech aplikace.</p>
</div>
<div class="paragraph">
<p>Architektura Spring Security frameworku pracuje s ordělením techto dvou kroků.</p>
</div>
<div class="paragraph">
<p>Kromě toho Spring security dále pracuje s:</p>
</div>
<div class="ulist">
<ul>
<li>
<p><strong>Password Storage</strong>: Tedy uchováváním hesel <em>bezpečně</em> ve vaší palikaci</p>
</li>
<li>
<p><strong>Servlet Filters</strong>: Spring security využíbá JEE Servelet filtry.</p>
</li>
</ul>
</div>
<div class="paragraph">
<p>Zde jsou některé důležité výhody Spring Security:</p>
</div>
<div class="ulist">
<ul>
<li>
<p>Integrace s rozhraním Servlet API.</p>
</li>
<li>
<p>Snadná rozšiřítelno pro o nové autentizační i autorizační mechanizmy.</p>
</li>
<li>
<p>Ochrana proti běžným útoků (například CSRF).</p>
</li>
<li>
<p>Snadná integrace se Spring MVC a tako s nástroji pro cloud.</p>
</li>
<li>
<p>Schopnost zabezpečit aplikaci proti útokům brutální síly.</p>
</li>
<li>
<p>Podpora konfigurace pomocí Javy kódu a anotací, příčemž možno použít i XML konfiguraci.</p>
</li>
<li>
<p>Schopnost zabezpšit všechny urovně aplikaci (vstupní body API, metody i databázi)</p>
</li>
</ul>
</div>
<div class="paragraph">
<p>Abychom zajistili základní zabezpečení jaro pro aplikace J2EE, postupujeme podle níže uvedených 3 kroků:</p>
</div>
<div class="olist arabic">
<ol class="arabic">
<li>
<p>Přidejte dependencises</p>
</li>
<li>
<p>Konfigurace Autentizace</p>
</li>
<li>
<p>Konfigurace Autorizace pomocí rolí.</p>
</li>
</ol>
</div>
<div class="paragraph">
<p>Pojďme se podívat na každý krok.</p>
</div>
<div class="paragraph">
<p><a href="https://www.javadevjournal.com/spring/what-is-spring-security/" class="bare">https://www.javadevjournal.com/spring/what-is-spring-security/</a></p>
</div>
<div class="sect2">
<h3 id="_authentication">Authentication</h3>
<div class="paragraph">
<p>Používá se k ověření, zda uživatel je tím za koho se vydává.
Je možné použít několik strategii (login/heslo, sertifikát, token, &#8230;&#8203;.)
Autentizace vytváří objekt `principal (uživatele, systému, který může provádět akci v aplikaci).</p>
</div>
<div class="paragraph">
<p>K tomu je potřeba:</p>
</div>
<div class="paragraph">
<p>.</p>
</div>
<div class="sect3">
<h4 id="_authorization">Authorization</h4>

</div>
</div>
<div class="sect2">
<h3 id="_přizpůsobení_authentication_managers">Přizpůsobení Authentication Managers</h3>
<div class="paragraph">
<p>Spring Security poskytuje pomocné třídy pro rychlou konfiguraci.</p>
</div>
<div class="paragraph">
<p>Nejčastěji používanou je <code>AuthenticationManagerBuilder</code>.</p>
</div>
<div class="paragraph">
<p>Ten umožňuje pracovat s uživateleli v paměti, JDBC nebo LDAP nebo pro přidání vlastní UserDetailsService.</p>
</div>
<div class="paragraph">
<p>Zde je příklad aplikace konfigurovající globální (nadřazenou) autentizační správu:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlightjs highlight"><code data-lang="java" class="language-java hljs">@Configuration
public class ApplicationSecurity extends WebSecurityConfigurerAdapter {

   ... // web stuff here

  @Autowired
  public initialize(AuthenticationManagerBuilder builder, DataSource dataSource) {
    builder
        .jdbcAuthentication()
        .dataSource(dataSource)
        .withUser("dave").password("secret").roles("USER");
  }

}</code></pre>
</div>
</div>
<div class="sect3">
<h4 id="_lokální_authentication_managers">Lokální Authentication Managers</h4>
<div class="paragraph">
<p>Tento příklad se týká webové aplikace s použitím <code>AuthenticationManagerBuilder</code></p>
</div>
<div class="paragraph">
<p>Všimněte si, že <code>AuthenticationManagerBuilder</code> je <code>@Autowired</code> do metody v <code>@Bean</code>.</p>
</div>
<div class="paragraph">
<p>Takto vytvoříme globální nastavení <code>AuthenticationManager</code></p>
</div>
<div class="paragraph">
<p>Naopak, kdybychom to udělali takto:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlightjs highlight"><code data-lang="java" class="language-java hljs">@Configuration
public class ApplicationSecurity extends WebSecurityConfigurerAdapter {

  @Autowired
  DataSource dataSource;

   ... // web stuff here

  @Override
  public configure(AuthenticationManagerBuilder builder) {
    builder
        .jdbcAuthentication()
        .dataSource(dataSource)
        .withUser("dave").password("secret").roles("USER");
  }

}</code></pre>
</div>
</div>
</div>
<div class="sect3">
<h4 id="_rozdíly_mezi_lokálním_a_globálním_nastavení">Rozdíly mezi lokálním a globálním nastavení</h4>
<div class="paragraph">
<p>Přetížení metody <code>configure</code>.</p>
</div>
<div class="paragraph">
<p>Ppak je <code>AuthenticationManagerBuilder</code> používán pouze k vytvoření "lokálního" autentizačního správce.</p>
</div>
<div class="paragraph">
<p>Spring Boot poskytuje výchozí globální <code>AuthenticationManager</code></p>
</div>
<div class="paragraph">
<p>Výchozí nastavení je dostatečně zabezpečené samo o sobě, nemusíte jej měnit.</p>
</div>
<div class="paragraph">
<p>Pokud provedete libovolnou konfiguraci, která vytváří službu AuthenticationManager, můžete ji často provést místně na prostředky, které chráníte a nemusíte se starat o globální výchozí nastavení.</p>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_authorization_or_access_control">Authorization or Access Control</h3>
<div class="paragraph">
<p>Jakmile je ověřování úspěšné, můžeme přejít na autorizaci.</p>
</div>
<div class="paragraph">
<p>O tu se stará <code>AccessDecisionManager</code>.</p>
</div>
<div class="paragraph">
<p>Existují tři implementace poskytnuté framevorkem.
- Všechny tři jsou opět integrované pomocí návarhového vzoru <strong>Chain of responsibility</strong> řetězce <code>AccessDecisionVoter</code>
- Stejný mechanizmuss jako u <code>ProviderManager</code>, který deleguje na <code>AuthenticationProviders</code>.</p>
</div>
<div class="paragraph">
<p><code>AccessDecisionVoter</code> vyhodnocuje <code>Authentication</code> a zabezpečená objek (reprezentující hlavního) a bezpečný objekt s kolekcí <code>ConfigAttributes</code>:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlightjs highlight"><code data-lang="java" class="language-java hljs">boolean supports(ConfigAttribute attribute);

boolean supports(Class&lt;?&gt; clazz);

int vote(Authentication authentication, S object,
        Collection&lt;ConfigAttribute&gt; attributes);</code></pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_accessdecisionvoter_a_proces_authorization">AccessDecisionVoter a proces Authorization</h3>
<div class="paragraph">
<p>Parametr <code>S objekt</code> je generický určen v definici <code>AccessDecisionManager</code></p>
</div>
<div class="paragraph">
<p><code>AccessDecisionVoter</code> - představuje všechno, k čemu by uživatel chtěl mít přístup:
- webový prostředek
- metoda v třídě Java</p>
</div>
<div class="paragraph">
<p><code>ConfigAttributes</code> jsou také velmi obecné:
- představuje atributy pro zabezpečení objektu.
- určují úroveň oprávnění k přístupu k objektu.</p>
</div>
<div class="paragraph">
<p><code>ConfigAttribute</code> je rozhraní, ale má pouze jednu metodu
- ta je poměrně obecná a vrací řetězec
- takže tyto řetězce nějakým způsobem zakódují záměr vlastníka zdroje
- vyjadřují pravidla o tom, kdo má k němu přístup.</p>
</div>
<div class="paragraph">
<p>Typický <code>ConfigAttribute</code> je:
- název role uživatele (<strong>ROLE_ADMIN</strong> nebo <strong>ROLE_AUDIT</strong>)
- často mají speciální formáty (například předponu <strong>ROLE_</strong>)
- nebo reprezentují výrazy, které je třeba vyhodnotit.</p>
</div>
<div class="sect3">
<h4 id="_výchozí_accessdecisionmanager">Výchozí AccessDecisionManager</h4>
<div class="paragraph">
<p>Většinou používáme pouze výchozí <code>AccessDecisionManager</code>, ten je založen na zásadě <code>AffirmativeBased</code></p>
</div>
<div class="paragraph">
<p>Jakékoli přizpůsobení se obvykle projevuje u voličů, a to buď přidáním nových nebo úpravou způsobu, jakým fungují stávající.</p>
</div>
<div class="paragraph">
<p>Je velmi běžné používat konfigurační výrazy <code>ConfigAttributes</code>, které jsou výrazy Expression Expression Language (SpEL)
- například <code>isFullyAuthenticated() &amp;&amp; hasRole(&#39;FOO&#39;)</code>.</p>
</div>
<div class="paragraph">
<p>To je podporováno aplikací <code>AccessDecisionVoter</code>, která zpracovává výrazy a vytváří pro ně kontext.</p>
</div>
<div class="paragraph">
<p>Rozšíření rozsahu výrazů, které lze zpracovat vyžaduje vlastní implementaci <code>SecurityExpressionRoot</code> a někdy také <code>SecurityExpressionHandler</code>.</p>
</div>
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_web_security">Web Security</h2>
<div class="sectionbody">
<div class="paragraph">
<p>Spring Security ve vrstvě webových stránek je založeno na servletových filtrech.</p>
</div>
<div class="paragraph">
<p>Na následujícím obrázku je znázorněno typické vrstvení zpracovatelů pro jeden požadavek HTTP.</p>
</div>
<div class="paragraph">
<p><span class="image"><img src="media/filters.png" alt="filters"></span></p>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_filter_chain">Filter chain</h2>
<div class="sectionbody">
<div class="paragraph">
<p>Spring Security je nainstalováno jako jediný filtr v řetězci.</p>
</div>
<div class="paragraph">
<p>Jeho typ concerete je ale <code>FilterChainProxy</code>.</p>
</div>
<div class="paragraph">
<p>V aplikaci Spring Boot je bezpečnostní filtr @Bean v ApplicationContext a je standardně nainstalován tak, aby byl aplikován na každou žádost.</p>
</div>
<div class="paragraph">
<p>Je nainstalován na pozici definovanou službou <code>SecurityProperties.DEFAULT_FILTER_ORDER</code>.</p>
</div>
<div class="paragraph">
<p>Ta je zase ukotvena v souboru <code>FilterRegistrationBean.REQUEST_WRAPPER_FILTER_MAX_ORDER</code></p>
</div>
<div class="paragraph">
<p>Z pohledu kontejneru Spring Security je jediný filtr, ale uvnitř jsou další filtry, z nichž každý hraje zvláštní roli.</p>
</div>
<div class="sect3">
<h4 id="_spring_security_filters">Spring security filters</h4>
<div class="paragraph">
<p><span class="image"><img src="media/security-filters.png" alt="security filters"></span></p>
</div>
</div>
<div class="sect2">
<h3 id="_detailnější_pohled">Detailnější pohled</h3>
<div class="paragraph">
<p>Ve skutečnosti je v bezpečnostním filtru dokonce ještě jedna vrstva, obvykle je instalována jako <code>DelegatingFilterProxy</code></p>
</div>
<div class="paragraph">
<p>Proxy deleguje na <code>FilterChainProxy</code>, který je vždy <code>@Bean</code>, obvykle s pevným jménem <code>springSecurityFilterChain</code>.</p>
</div>
<div class="paragraph">
<p>Jedná se o filtr <code>FilterChainProxy</code>, který obsahuje celou bezpečnostní logiku uspořádanou uvnitř jako řetězec (nebo řetězy) filtrů.</p>
</div>
<div class="paragraph">
<p>Všechny filtry mají stejné API (všechny implementují rozhraní filtru ze Servlet Spec) a všichni mají možnost vetovat zbytek řetězce.</p>
</div>
<div class="paragraph">
<p>K dispozici mohou být více filtračních řetězců, které spravuje Spring Security na stejné úrovni filtru <code>FilterChainProxy</code> a všechny jsou pro kontejner neznámé.</p>
</div>
<div class="paragraph">
<p>Filtr obsahuje seznam filtrovacích řetězců a odesílá požadavek na první řetězec, který odpovídá.</p>
</div>
<div class="paragraph">
<p>Na následujícím obrázku je zobrazeno odeslání na základě shody cesty požadavku (<code>/foo/<strong></code> odpovídá před <code>/</strong></code>).</p>
</div>
<div class="paragraph">
<p>Nejdůležitějším znakem tohoto procesu odeslání je, že pouze jeden řetězec zpracovává žádost.</p>
</div>
<div class="sect3">
<h4 id="_vnitřní_členení_filtrů">Vnitřní členení filtrů</h4>
<div class="paragraph">
<p><span class="image"><img src="media/security-filters-dispatch.png" alt="security filters dispatch"></span></p>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_creating_and_customizing_filter_chains">Creating and Customizing Filter Chains</h3>
<div class="paragraph">
<p>Výchozí řetězec filtru v Spring Boot app (pro <code>/**</code>) má předdefinovanou řadu SecurityProperties.BASIC_AUTH_ORDER.</p>
</div>
<div class="paragraph">
<p>Můžete jej úplně vypnout nastavením parametru <code>security.basic.enabled = false</code></p>
</div>
<div class="paragraph">
<p>Chcete-li jednoduše přidat <code>@Bean</code> typu <code>WebSecurityConfigurerAdapter</code> (nebo <code>WebSecurityConfigurer</code>)</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlightjs highlight"><code data-lang="java" class="language-java hljs">@Configuration
@Order(SecurityProperties.BASIC_AUTH_ORDER - 10)
public class ApplicationConfigurerAdapter extends WebSecurityConfigurerAdapter {
  @Override
  protected void configure(HttpSecurity http) throws Exception {
    http.antMatcher("/foo/**")
     ...;
  }
}</code></pre>
</div>
</div>
<div class="sect3">
<h4 id="_websecurityconfigureradapter">WebSecurityConfigurerAdapter</h4>
<div class="paragraph">
<p>Mnoho aplikací má zcela odlišné přístupové pravidlo pro jednu sadu zdrojů ve srovnání s jinou.</p>
</div>
<div class="paragraph">
<p>Například aplikace, která je hostitelem uživatelského rozhraní a API zálohování, může podporovat autentizaci založenou na cookie přesměrováním na přihlašovací stránku pro součásti uživatelského rozhraní a autentizaci založenou na tokenu s odpovědí 401 na neověřené žádosti o součásti rozhraní API.</p>
</div>
<div class="paragraph">
<p>Každá sada zdrojů má svůj vlastní WebSecurityConfigurerAdapter s jedinečnou objednávkou a vlastním požadavkem na porovnávání.</p>
</div>
<div class="paragraph">
<p>Pokud se odpovídající pravidla překrývají, vyhraje nejstarší uspořádaný řetězec filtru.</p>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_request_matching_for_dispatch_and_authorization">Request Matching for Dispatch and Authorization</h3>
<div class="paragraph">
<p>Řetěz bezpečnostního filtru má modul požadavku, který se používá k rozhodování, zda se má použít na požadavek HTTP.</p>
</div>
<div class="paragraph">
<p>Jakmile je rozhodnuto o použití určitého řetězce filtrů, nejsou použity žádné další.</p>
</div>
<div class="paragraph">
<p>Ovšem ve filtrovacím řetězci můžete mít mnohem jemnější kontrolu nad autorizací tím, že nastavíte další parametry v konfiguraci <code>HttpSecurity</code>.</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlightjs highlight"><code data-lang="java" class="language-java hljs">@Configuration
@Order(SecurityProperties.BASIC_AUTH_ORDER - 10)
public class ApplicationConfigurerAdapter extends WebSecurityConfigurerAdapter {
  @Override
  protected void configure(HttpSecurity http) throws Exception {
    http.antMatcher("/foo/**")
      .authorizeRequests()
        .antMatchers("/foo/bar").hasRole("BAR")
        .antMatchers("/foo/spam").hasRole("SPAM")
        .anyRequest().isAuthenticated();
  }
}</code></pre>
</div>
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_method_security">Method Security</h2>
<div class="sectionbody">
<div class="paragraph">
<p>Stejně jako podpora pro zabezpečení webových aplikací, Spring Security nabízí podporu pro uplatňování pravidel přístupu k Java metodám.</p>
</div>
<div class="paragraph">
<p>Pro Spring Security je to jen jiný typ "chráněného zdroje".</p>
</div>
<div class="paragraph">
<p>Pro uživatele to znamená, že pravidla přístupu jsou deklarována pomocí stejného formátu řetězců <code>ConfigAttribute</code> (např. Rolí nebo výrazů), ale na jiném místě ve vašem kódu.</p>
</div>
<div class="paragraph">
<p>Prvním krokem je umožnit zabezpečení metod, například v konfiguraci nejvyšší úrovně naší aplikace:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlightjs highlight"><code data-lang="java" class="language-java hljs">@SpringBootApplication
@EnableGlobalMethodSecurity(securedEnabled = true)
public class SampleSecureApplication {
}</code></pre>
</div>
</div>
<div class="paragraph">
<p>Následně můžeme definovat přístupová práva u metod:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlightjs highlight"><code data-lang="java" class="language-java hljs">@Service
public class MyService {

  @Secured("ROLE_USER")
  public String secure() {
    return "Hello Security";
  }

}</code></pre>
</div>
</div>
<div class="paragraph">
<p>Tento vzorek je služba se zabezpečenou metodou.</p>
</div>
<div class="paragraph">
<p>Pokud jaro vytvoří <code>@Bean</code> tohoto typu, pak bude proxy a volající budou muset projít bezpečnostním stíhačem předtím, než je metoda skutečně provedena.</p>
</div>
<div class="paragraph">
<p>Je-li přístup odepřen, volající získá namísto skutečného výsledku metody AccessDeniedException.</p>
</div>
<div class="paragraph">
<p>Existují další poznámky, které lze použít na metody pro vynucení bezpečnostních omezení, zejména <code>@PreAuthorize</code> a <code>@PostAuthorize</code>, které umožňují psát výrazy obsahující odkazy na parametry metody a návratové hodnoty.</p>
</div>
<div class="sect2">
<h3 id="_todo">TODO</h3>
<div class="paragraph">
<p><a href="https://bezkoder.com/spring-boot-jwt-auth-mongodb/" class="bare">https://bezkoder.com/spring-boot-jwt-auth-mongodb/</a></p>
</div>
</div>
</div>
</div>
</div>
<div id="footer">
<div id="footer-text">
Version 1.1<br>
Last updated 2020-08-24 14:27:48 +0200
</div>
</div>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.15.6/styles/github.min.css">
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.15.6/highlight.min.js"></script>
<script>hljs.initHighlighting()</script>
</body>
</html>